package pawa.tp03;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.json.Json;
import javax.json.JsonArrayBuilder;
import javax.json.JsonBuilderFactory;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;
import javax.json.JsonValue;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


//La classe du contrôleur
@WebServlet(urlPatterns = {"/MovieWSServlet", "/MovieWSServlet/*" })
public class MovieWSServlet extends HttpServlet {

	private static final long serialVersionUID = 6489069438791307255L;


	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		try {
			
			MovieDB db = new MovieDB();
			//Le JSON résultat :
			JsonObjectBuilder b = Json.createObjectBuilder();

			String uri = request.getRequestURI();
			System.err.println(uri);
			if (uri.endsWith("MovieWSServlet")) {
				//Comme dans MovieListServlet
				String froms = request.getParameter("from");
				String tos = request.getParameter("to");

				int from = 0;
				try {
					from = Integer.parseInt(froms);
				} catch (NumberFormatException e) {
				}
				
				int to = from + 10;

				try {
					to = Integer.parseInt(tos);
				} catch (NumberFormatException e) {
				}
				b = b.add("status", "success");
				List<Pair<Integer, String>> res = db.getMovieList(from, to);
				b = b.add("size", res.size());
				
				JsonArrayBuilder ab = Json.createArrayBuilder();
				for (Pair<Integer, String> p : res) {
					ab = ab.add(p.getFirst());
				}
				b.add("ids", ab);		
			} else {
				String[] fields = uri.split("/");
				String mid = fields[fields.length - 1];   /* On prend le dernier composant, séparé par des / */;
				if (mid.matches("^mid[0-9]+$")) {
					//mid commence bien par "mid" suivi de chiffres.
					String id = mid.substring(3); //prend la fin de la chaîne
					try {
						String title = db.getTitle(Integer.parseInt(id));
						if (title != null) {
							b.add("status",  "success");
							b.add("mid", id);
							b.add("title", title);
						} else {
							b.add("status", "error");
							b.add("error", "Aucun film avec cet id");
						
						}
					} catch (NumberFormatException e) {
						b.add("status", "error");
						b.add("error", "mid invalide");
					};		
				} else {
					b.add("status", "error");
					b.add("error", "URL invalide");
				}
			}
						
			request.setAttribute("json", b.build());
			RequestDispatcher rd = request.getRequestDispatcher("/WEB-INF/jsp/json.jsp");
			rd.forward(request, response);
			
			
		} catch (Exception e) { throw new ServletException(e); }
		
	}


}

